use std::path::PathBuf;

use based::request::{respond_html, StringResponse};
use maud::html;
use rocket::{get, State};

use crate::archive::WebsiteArchive;

#[get("/")]
pub async fn index() -> StringResponse {
    // TODO : websites overview grid
    unimplemented!()
}

#[get("/s/<domain>/<path..>?<time>")]
pub async fn render_website(
    domain: &str,
    path: PathBuf,
    time: Option<&str>,
    arc: &State<WebsiteArchive>,
) -> Option<StringResponse> {
    let document = arc.get_domain(domain).path(path.to_str().unwrap());

    let content = document.render_local(if time.is_some() {
        Some(time.unwrap().to_string())
    } else {
        None
    });

    if let Some(content) = content {
        return Some(respond_html(&content));
    } else {
        if std::env::var("DOWNLOAD_ON_DEMAND")
            .unwrap_or("false".to_string())
            .as_str()
            == "true"
        {
            arc.archive_url(&format!("https://{domain}/{}", path.to_str().unwrap()));

            return Some(respond_html(&document.render_local(if time.is_some() {
                Some(time.unwrap().to_string())
            } else {
                None
            })?));
        }
    }

    None
}
